*:*********************************************************************
*:
*: Procedure file: C:\TEMP\PRGS\IN_USE.PRG
*:
*:         System: Fleet management system V 3.5
*:         Author: Peter E. Hecht
*:      Copyright (c) 1992, VELCOR Leasing Corporation & P. E. Hecht
*:  Last modified: 12/23/92     11:40
*:
*:         Set by: VELCOR.PRG                        
*:               : RATEFACT.PRG                      
*:               : STATUS.PRG                        
*:               : CARCNT.PRG                        
*:               : MAINREPT.PRG                      
*:               : UTILMENU.PRG                      
*:               : X_TO_N.PRG                        
*:               : AUCTION.SPR                       
*:               : REPOMENU.PRG                      
*:               : INUSE.SPR                         
*:               : PO_LOC.PRG                        
*:               : PO_LIEN.PRG                       
*:               : AUCTFIND.SPR                      
*:               : MM_HIST.PRG                       
*:               : CC.PRG                            
*:               : DISTAX             (procedure in DISPOSE.PRG)
*:               : POSTAT             (procedure in PO.PRG)
*:               : AFILL              (procedure in ASCHED.PRG)
*:               : COMPARE            (procedure in STATCHK.PRG)
*:               : PACKSTAT           (procedure in FMSSYS.PRG)
*:               : CARMAKE            (procedure in REPOMENU.PRG)
*:               : CPRINT2            (procedure in CPRINT.PRG)
*:               : WHENTITLE()        (function  in POTR.PRG)
*:               : LIEN_OK()          (function  in POTR.PRG)
*:               : BYLIEN             (procedure in ON_ORDER.PRG)
*:
*:      Documented 12/23/92 at 11:48               FoxDoc  version 2.10b
*:*********************************************************************
PARAMETER cdbf, corder, cexcl, ctag, cpath, coldord, calias
* Coldord will contain old order before set to corder.
PRIVATE used_before, coldord, cerrorset, nparas

* Save number of parameters in case error routine is called.
nparas = PARAMETERS()

IF PARAMETERS() < 2
	WAIT WINDOW NOWAIT "Incorrect parameters in in_use.prg"
	RETURN .F.
ENDIF
IF PARAMETERS() < 7
	STORE "" TO calias
ENDIF
IF PARAMETERS() < 6
	STORE "" TO coldord
ENDIF
IF PARAMETERS() < 5
	STORE pathdbf TO cpath
ENDIF
IF PARAMETERS() < 4
	STORE .T. TO ctag
ENDIF
IF PARAMETERS() < 3
	STORE .F. TO cexcl
ENDIF
STORE ON( "ERROR" ) TO cerrorset

* Line below should only be used for debugging.
* ON ERROR DO checkwas WITH cdbf  && check work areas

STORE ALLTRIM( cdbf ) TO cdbf
STORE .F. TO used_before

IF USED( cdbf ) OR USED( calias )
	IF EMPTY( calias )
		SELECT ( cdbf )
	ELSE
		SELECT ( calias )
	ENDIF		
	STORE ORDER() TO coldord
	IF cexcl
		IF EMPTY( calias )
			USE ( cpath + cdbf ) EXCLUSIVE
		ELSE
			USE ( cpath + cdbf ) ALIAS ( calias ) EXCLUSIVE
		ENDIF
		STORE ORDER() TO coldord
		SET ORDER TO ( coldord )
	ENDIF
	IF nparas >= 2
		STORE ORDER() TO coldord
		SET ORDER TO ( corder )
	ENDIF
	used_before = .T.
ELSE
	SELECT 0
	IF cexcl
		IF EMPTY( calias )
			USE ( cpath + cdbf ) EXCLUSIVE
		ELSE
			USE ( cpath + cdbf ) ALIAS ( calias ) EXCLUSIVE
		ENDIF
	ELSE
		IF EMPTY( calias )
			USE ( cpath + cdbf ) 
		ELSE
			USE ( cpath + cdbf ) ALIAS ( calias ) 
		ENDIF
	ENDIF
	IF nparas >= 2
		STORE ORDER() TO coldord
		SET ORDER TO ( corder )
	ENDIF
	used_before = .F.
ENDIF

* Used only with debugging.
* ON ERROR &cerrorset

RETURN ( used_before )
*: EOF: IN_USE.PRG


PROCEDURE checkwas
	PARAMETERS cdbf
	* This can sprused up a little.
	WAIT cbdf + " HAS A PROBLEM!  CONTINUE AT YOUR OWN RISK" WINDOW
	IF LASTKEY() = 27
		CANCEL
	ENDIF
	PRIVATE bottom, top, current, cdbfname, cperpos, cslashpos
	STORE SELECT( 1 ) TO top
	STORE 1 TO bottom
	FOR current = bottom to top
		STORE DBF( current ) TO cdbfname
		STORE RAT( ".", cdbfname ) TO cperpos
		STORE RAT( "\", cdbfname ) TO cslashpos
		STORE SUBSTR( cdbfname, cslashpos+1, ;
			( LEN( cdbfname ) - cslashpos ) -4 ) TO cdbfname
		IF cdbf = cdbfname
			SELECT ( current )
			USE
			RETRY
		ENDIF
			
	NEXT
	RETURN
	